(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[         0,          0]
NotebookDataLength[     29475,        750]
NotebookOptionsPosition[     27277,        690]
NotebookOutlinePosition[     27630,        706]
CellTagsIndexPosition[     27587,        703]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Homework 4: Simple DMRG", "Title",
 CellChangeTimes->{{3.731734772091714*^9, 
  3.731734811212879*^9}},ExpressionUUID->"da09aa66-471d-4279-88bf-\
6dec1671e47e"],

Cell["\<\
The goal of this homework is to construct a simple Density Matrix \
Renormalization Group (DMRG) code in the framework of Matrix Product States \
(MPS).\
\>", "Text",
 CellChangeTimes->{{3.731734821923032*^9, 
  3.731734864447945*^9}},ExpressionUUID->"e72bb2a1-d4c1-41a7-b7ab-\
5b1e8beea442"],

Cell[TextData[{
 StyleBox["Step 1: Construct a random MPS",
  FontWeight->"Bold"],
 "\nExecute the code below to construct a MPS for a spin-1/2 chain of length \
n=5 with bond dimension \[Chi]=3;\n\nindices:\nMPS[[i,\[Sigma],k,l]]\ni -- \
site\n\[Sigma] -- spin\nk -- internal bond to the left\nl -- internal bond to \
the right"
}], "Text",
 CellChangeTimes->{{3.7317348817840033`*^9, 3.731734977859054*^9}, {
  3.7317351816422367`*^9, 3.731735275668829*^9}, {3.731735439885748*^9, 
  3.731735484221189*^9}, {3.73173614098458*^9, 3.731736146800745*^9}, {
  3.731740165230775*^9, 
  3.731740165308712*^9}},ExpressionUUID->"7c41a873-fd8d-497e-a151-\
218992cb56e5"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "This", " ", "function", " ", "returns", " ", "a", " ", "random"}], ",", 
    " ", 
    RowBox[{"but", " ", "valid"}], ",", " ", 
    RowBox[{"MPS", " ", "state"}], ",", " ", 
    RowBox[{
    "that", " ", "is", " ", "tapered", " ", "on", " ", "the", " ", 
     "edges"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"mkMPSt", "[", 
      RowBox[{"\[Chi]_", ",", "dd_", ",", " ", "n_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "MPS", "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MPS", "=", 
         RowBox[{"Table", "[", "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{
            RowBox[{"If", "[", 
             RowBox[{
              RowBox[{"i", "<=", 
               FractionBox["n", "2"]}], ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"s1", "=", 
                RowBox[{"Min", "[", 
                 RowBox[{
                  SuperscriptBox["2", 
                   RowBox[{"i", "-", "1"}]], ",", "\[Chi]"}], "]"}]}], ";", 
               "\[IndentingNewLine]", 
               RowBox[{"s2", "=", 
                RowBox[{"Min", "[", 
                 RowBox[{
                  SuperscriptBox["2", "i"], ",", "\[Chi]"}], "]"}]}], ";"}], 
              "\[IndentingNewLine]", ",", "\[IndentingNewLine]", 
              RowBox[{
               RowBox[{"s1", "=", 
                RowBox[{"Min", "[", 
                 RowBox[{
                  SuperscriptBox["2", 
                   RowBox[{"n", "-", "i", "+", "1"}]], ",", "\[Chi]"}], 
                 "]"}]}], ";", "\[IndentingNewLine]", 
               RowBox[{"s2", "=", 
                RowBox[{"Min", "[", 
                 RowBox[{
                  SuperscriptBox["2", 
                   RowBox[{"n", "-", "i"}]], ",", "\[Chi]"}], "]"}]}], 
               ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
            "\[IndentingNewLine]", 
            RowBox[{"RandomReal", "[", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"s1", ",", "s2"}], "}"}]}], "]"}]}], 
           "\[IndentingNewLine]", ",", 
           RowBox[{"{", 
            RowBox[{"i", ",", "1", ",", "n"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"j", ",", "1", ",", "dd"}], "}"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "MPS", "]"}], ";"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"\[Chi]", "=", "3"}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{"Bond", " ", "Dimension"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"n", "=", "5"}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{"Chain", " ", "length"}], " ", "*)"}], "\[IndentingNewLine]", 
    RowBox[{"dd", "=", "2"}], ";", " ", 
    RowBox[{"(*", " ", 
     RowBox[{
     "size", " ", "of", " ", "the", " ", "Hilbert", " ", "space", " ", "on", 
      " ", "each", " ", "site"}], " ", "*)"}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", 
    RowBox[{"MPS", "=", 
     RowBox[{"mkMPSt", "[", 
      RowBox[{"\[Chi]", ",", "dd", ",", " ", "n"}], "]"}]}], ";"}], "  ", 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"Dimensions", "[", "#", "]"}], "&"}], "/@", "MPS"}]}]}]], "Input",\

 CellChangeTimes->{{3.73173510909061*^9, 3.731735126224483*^9}, {
  3.731735281643159*^9, 3.731735299996235*^9}, {3.731735353789386*^9, 
  3.7317354354190893`*^9}, {3.731739045249765*^9, 
  3.731739045372428*^9}},ExpressionUUID->"17821929-b98a-40c0-a22d-\
707fc8d5bc46"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.731735300249296*^9, 3.731735359746385*^9, 
  3.7317354888601933`*^9, 
  3.731739045628784*^9},ExpressionUUID->"769dd58c-ddb5-4f34-99a4-\
a32be6fde816"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Step 2: MPS -> Exact Form\n",
  FontWeight->"Bold"],
 "write a function that evaluates the coefficient of the configuration \
config. Use your function to compute the coefficient of each basis element \
thus converting the MPS you obtained in the first step into exact form."
}], "Text",
 CellChangeTimes->{{3.731735329392005*^9, 3.7317353416162653`*^9}, {
  3.7317355010962048`*^9, 3.731735598937356*^9}, {3.731735701695459*^9, 
  3.731735720741008*^9}, {3.7317361234683323`*^9, 
  3.7317361336043673`*^9}},ExpressionUUID->"50a2c2be-9e63-44e3-a0e1-\
86c2c5a328b7"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
   "Computes", " ", "the", " ", "coefficient", " ", "of", " ", "the", " ", 
    "configuration", " ", "given", " ", "an", " ", "MPS", " ", "state"}], " ",
    "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"\[Psi]MPSEval", "[", 
     RowBox[{"MPS_", ",", "config_"}], "]"}], " ", ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ","}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"figure", " ", "out", " ", "what", " ", "goes", " ", "here"}], 
      " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.731736095130192*^9, 
  3.73173610534485*^9}},ExpressionUUID->"013792d5-11c6-45bc-be8b-\
469eeecf0630"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"basis", "=", 
  RowBox[{"Tuples", "[", 
   RowBox[{
    RowBox[{"Range", "[", "dd", "]"}], ",", "n"}], "]"}]}]], "Input",Expressio\
nUUID->"c911218f-76de-405f-8a08-05c35121d25f"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "1", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "2", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "1", ",", "2", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "1", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "1", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "1", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "2", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1", ",", "2", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "1", ",", "2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2", ",", "1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2", ",", "1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2", ",", "2", ",", "2", ",", "2"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.73173573024722*^9},ExpressionUUID->"8f8be912-151e-42b1-b5f9-1c83f64393ca"]
}, Open  ]],

Cell[TextData[{
 StyleBox["Step 3: Normalization: ",
  FontWeight->"Bold"],
 "\n\t(1) write a function that computes the inner product of two MPSs \n\t\
(2) write a function that multiplies your MPS by a scalar \n\t(3) normalize \
your MPS\n\t(4) verify that your MPS is really normalized by converting it to \
exact form and checking normalization"
}], "Text",
 CellChangeTimes->{{3.731735329392005*^9, 3.7317353416162653`*^9}, {
  3.7317355010962048`*^9, 3.731735552272147*^9}, {3.731735756854334*^9, 
  3.731735888793417*^9}, {3.731736058410542*^9, 
  3.731736058971941*^9}},ExpressionUUID->"0c893a67-4942-4379-bb26-\
f747ed015f75"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{"computes", " ", "the", " ", "inner", " ", "product", " ", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{
      SubscriptBox["\[Psi]", "1"], "|", 
      SubscriptBox["\[Psi]", "2"]}], "\[RightAngleBracket]"}], " ", "of", " ",
     "two", " ", "MPS", " ", "wave", " ", 
    RowBox[{"functions", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"InnerProduct", "[", 
      RowBox[{"MPS1_", ",", "MPS2_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ","}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"figure", " ", "out", " ", "what", " ", "goes", " ", "here"}], 
       " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{" ", 
      RowBox[{
       RowBox[{
       "computes", " ", "the", " ", "scaler", " ", "product", " ", "scalar"}],
        "|", "\[Psi]"}], "\[RightAngleBracket]"}], " ", "of", " ", "a", " ", 
     "scalara", " ", "and", " ", "an", " ", "MPS", " ", "wave", " ", 
     RowBox[{"function", "."}]}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"ScalarMultiply", "[", 
      RowBox[{"MPS1_", ",", "scalar_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", "}"}], ","}], "\[IndentingNewLine]", 
      RowBox[{"(*", " ", 
       RowBox[{"figure", " ", "out", " ", "what", " ", "goes", " ", "here"}], 
       " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.731735901270759*^9, 3.731735944514638*^9}, {
  3.731736023658939*^9, 
  3.7317360829459667`*^9}},ExpressionUUID->"a42616c0-05b4-49e6-957a-\
648c4ae2f0cf"],

Cell[BoxData[
 RowBox[{
  RowBox[{"MPSn", "=", 
   RowBox[{"ScalarMultiply", "[", 
    RowBox[{"MPS", ",", 
     SqrtBox[
      RowBox[{"ScalarProduct", "[", 
       RowBox[{"MPS", ",", "MPS"}], "]"}]]}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.7317359456893806`*^9, 
  3.731735979558234*^9}},ExpressionUUID->"463112a0-ce11-4c68-af60-\
9ffea4a520b7"],

Cell[TextData[{
 StyleBox["Step 4: Construct the Hamiltonian: ",
  FontWeight->"Bold"],
 "\n\n(1) Write a function that constructs the MPO representation of the \
Hamiltonian\n\n\t",
 Cell[BoxData[
  FormBox[
   RowBox[{"H", "=", 
    RowBox[{
     RowBox[{"J", 
      RowBox[{
       SubsuperscriptBox["\[Sum]", 
        RowBox[{"i", "=", "1"}], 
        RowBox[{"n", "-", "1"}]], 
       RowBox[{
        SubsuperscriptBox["\[Sigma]", "i", "z"], 
        SubsuperscriptBox["\[Sigma]", 
         RowBox[{"i", "+", "1"}], "z"]}]}]}], "+", 
     RowBox[{"h", 
      RowBox[{
       SubsuperscriptBox["\[Sum]", 
        RowBox[{"i", "=", "1"}], "n"], 
       SubsuperscriptBox["\[Sigma]", "i", "x"]}]}]}]}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "663f9f43-f355-4feb-817d-0fbbdc0c8c60"],
 "\n\n(2) Write a function that calculates the expectation value ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{
     SubscriptBox["\[Psi]", "1"], "|", "H", "|", 
     SubscriptBox["\[Psi]", "2"]}], "\[RightAngleBracket]"}], 
   TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "41d46c81-9cc7-4982-b888-db8b8dba6c36"],
 "\n(3) Compute the expectation value ",
 Cell[BoxData[
  FormBox[
   RowBox[{"\[LeftAngleBracket]", 
    RowBox[{"MPSn", "|", "H", "|", "MPSn"}], "\[RightAngleBracket]"}], 
   TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "14fb4b4b-668a-4995-8e86-9cb4ff4d0684"],
 " using the state ",
 Cell[BoxData[
  FormBox["MPSn", TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "cb2072fb-675b-4b83-abcb-bed9c36384fd"],
 " from step 3 and the Hamiltonian with ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["J", "i"], "=", "1"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "3a34dbd5-d8c2-4773-b1ca-e37a963860f0"],
 " and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SubscriptBox["h", "i"], "=", "1.2"}], TraditionalForm]],
  FormatType->"TraditionalForm",ExpressionUUID->
  "b9740446-e4b7-45b9-901f-6a5608b07009"],
 ". Verify your answer using exact representation of the Hamiltonian and the \
state."
}], "Text",
 CellChangeTimes->{{3.731735329392005*^9, 3.7317353416162653`*^9}, {
  3.7317355010962048`*^9, 3.731735552272147*^9}, {3.731735756854334*^9, 
  3.731735888793417*^9}, {3.731736058410542*^9, 3.731736058971941*^9}, {
  3.731736188943974*^9, 3.731736223570628*^9}, {3.731736276075097*^9, 
  3.73173638993862*^9}, {3.731736479687994*^9, 3.7317365998042727`*^9}, {
  3.73174017791369*^9, 
  3.731740239457725*^9}},ExpressionUUID->"3a9b66ef-04f9-4a2e-ad16-\
0aea4a45f0b1"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{
    RowBox[{"mkHamiltonianMatrix", "[", 
     RowBox[{"Jvec_", ",", " ", "hvec_"}], "]"}], ":=", 
    RowBox[{"[", 
     RowBox[{
      RowBox[{"{", "}"}], ","}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"figure", " ", "out", " ", "what", " ", "goes", " ", "here"}], 
      " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}], 
  "\[IndentingNewLine]", "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"evaluate", " ", 
    RowBox[{"\[LeftAngleBracket]", 
     RowBox[{"MPS1", " ", "|", " ", "MPO", " ", "|", " ", "MPS2"}], 
     "\[RightAngleBracket]"}], " ", "using", " ", "starting", " ", "from", 
    " ", "Left"}], " ", "*)"}]}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"ComputeEnergyLeft", "[", 
    RowBox[{"MPS1_", ",", "MPO_", ",", "MPS2_"}], "]"}], ":=", 
   RowBox[{"Module", "[", 
    RowBox[{
     RowBox[{"{", "}"}], ","}], "\[IndentingNewLine]", 
    RowBox[{"(*", " ", 
     RowBox[{"figure", " ", "out", " ", "what", " ", "goes", " ", "here"}], 
     " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}]}], "Input",
 CellChangeTimes->{{3.731736453431333*^9, 3.731736474040861*^9}, {
  3.731736607117441*^9, 3.7317366074657793`*^9}, {3.7317366566182413`*^9, 
  3.731736693685073*^9}},ExpressionUUID->"02680977-89b0-47dd-8f32-\
8fcc9f17381e"],

Cell[TextData[{
 StyleBox["Step 5: Implement Sweeps (without using canonical form)",
  FontWeight->"Bold"],
 "\n\nBelow is a function that computes the overlap matrix on site i\n\n(1) \
Write a function that computes the effective Hamiltonian on site i (feel free \
to use my function as a starting point)\n\n(2) Write a function that given an \
MPS, an MPO, and the site index i constructs the generalized eigenvalue \
problem and returns the MPS with an updated set of matrices on site i.\n\n(3) \
Write a function that sweeps over the sites of the chain. For each site i:\n\t\
(a) update the matrices on site i of the MPS using your function from (2)\n\t\
(b) normalize the MPS\n\t(c) compute and save the expectation value of the \
energy\n\nFor the remaining two parts we shall consider three sets of \
parameters for the Hamiltonian:\n\t(a) J=1\t  h=0\n\t(b) J=0   h=1\n\t(c) J=1 \
  h=1\n\n(4) What is the expectation value of the energy for the ground state \
for the three cases? What are the ground state wave functions.\n\n(5) What do \
you expect to happen to the expectation value of the energy as you sweep? \
Plot the expectation value of the energy as you sweep (several times) and \
make sure the results make sense. Does your final answer match your \
expectations from (4)?"
}], "Text",
 CellChangeTimes->{{3.731735329392005*^9, 3.7317353416162653`*^9}, {
  3.7317355010962048`*^9, 3.731735552272147*^9}, {3.731735756854334*^9, 
  3.731735888793417*^9}, {3.731736058410542*^9, 3.731736058971941*^9}, {
  3.731736188943974*^9, 3.731736223570628*^9}, {3.731736276075097*^9, 
  3.73173638993862*^9}, {3.731736479687994*^9, 3.7317365998042727`*^9}, {
  3.731736723789954*^9, 3.731737064147217*^9}, {3.731737699075243*^9, 
  3.7317381030170307`*^9}},ExpressionUUID->"54607de3-0f12-421f-9552-\
2e95e42f3bee"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{
    "given", " ", "two", " ", "tensors", " ", "t1", " ", "and", " ", "t2"}], 
    ",", " ", 
    RowBox[{
    "contract", " ", "the", " ", "indecies", " ", "i1", " ", "and", " ", "i2",
      " ", "and", " ", "return", " ", "the", " ", "resulting", " ", 
     "tensor"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"myContract", "[", 
     RowBox[{"t1_", ",", "t2_", ",", "i1_", ",", "i2_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"d1", ",", "d2", ",", "flip1", ",", "flip2"}], "}"}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"d1", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Dimensions", "[", "t1", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"d2", "=", 
        RowBox[{"Length", "[", 
         RowBox[{"Dimensions", "[", "t2", "]"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{
           RowBox[{"Dimensions", "[", "t1", "]"}], ",", "\"\< \>\"", ",", 
           RowBox[{"Dimensions", "[", "t2", "]"}]}], "]"}], ";"}], "*)"}], 
       "\[IndentingNewLine]", 
       RowBox[{"flip1", "=", 
        RowBox[{"Insert", "[", 
         RowBox[{
          RowBox[{"Range", "[", 
           RowBox[{"d1", "-", "1"}], "]"}], ",", "d1", ",", "i1"}], "]"}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"flip2", "=", 
        RowBox[{"Insert", "[", 
         RowBox[{
          RowBox[{"1", "+", 
           RowBox[{"Range", "[", 
            RowBox[{"d2", "-", "1"}], "]"}]}], ",", "1", ",", "i2"}], "]"}]}],
        ";", "\[IndentingNewLine]", 
       RowBox[{"(*", 
        RowBox[{
         RowBox[{"Print", "[", 
          RowBox[{"flip1", ",", "\"\< \>\"", ",", "flip2"}], "]"}], ";"}], 
        "*)"}], "\[IndentingNewLine]", 
       RowBox[{"Return", "[", 
        RowBox[{
         RowBox[{"Transpose", "[", 
          RowBox[{"t1", ",", "flip1"}], "]"}], ".", 
         RowBox[{"Transpose", "[", 
          RowBox[{"t2", ",", "flip2"}], "]"}]}], "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", " ", 
    RowBox[{
    "given", " ", "an", " ", "MPS", " ", "and", " ", "a", " ", "site", " ", 
     "computes", " ", "the", " ", "overlap", " ", "matrix", " ", "that", " ", 
     "goes", " ", "into", " ", "the", " ", "generalized", " ", "eigenvalue", 
     " ", "problem"}], " ", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"computeOverlap", "[", 
      RowBox[{"MPS_", ",", "i_"}], "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
        "L", ",", "R", ",", "dd", ",", "op", ",", "id", ",", "dL", ",", 
         "dR"}], "}"}], ",", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"dd", "=", 
         RowBox[{"Length", "[", 
          RowBox[{"MPS", "[", 
           RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"L", "=", 
         RowBox[{"{", 
          RowBox[{"{", "1", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"R", "=", 
         RowBox[{"{", 
          RowBox[{"{", "1", "}"}], "}"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"L", "=", 
            RowBox[{"myContract", "[", 
             RowBox[{"L", ",", 
              RowBox[{"MPS", "[", 
               RowBox[{"[", "j", "]"}], "]"}], ",", "1", ",", "2"}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"L", "=", 
            RowBox[{"myContract", "[", 
             RowBox[{"L", ",", 
              RowBox[{"MPS", "[", 
               RowBox[{"[", "j", "]"}], "]"}], ",", "1", ",", "2"}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"L", "=", 
            RowBox[{"TensorContract", "[", 
             RowBox[{"L", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "}"}]}], "]"}]}], ";"}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "1", ",", 
            RowBox[{"i", "-", "1"}]}], "}"}]}], "]"}], ";", 
        "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Do", "[", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{
           RowBox[{"R", "=", 
            RowBox[{"myContract", "[", 
             RowBox[{"R", ",", 
              RowBox[{"MPS", "[", 
               RowBox[{"[", "j", "]"}], "]"}], ",", "1", ",", "3"}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"R", "=", 
            RowBox[{"myContract", "[", 
             RowBox[{"R", ",", 
              RowBox[{"MPS", "[", 
               RowBox[{"[", "j", "]"}], "]"}], ",", "1", ",", "3"}], "]"}]}], 
           ";", "\[IndentingNewLine]", 
           RowBox[{"R", "=", 
            RowBox[{"TensorContract", "[", 
             RowBox[{"R", ",", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"1", ",", "3"}], "}"}], "}"}]}], "]"}]}], ";"}], 
          "\[IndentingNewLine]", ",", 
          RowBox[{"{", 
           RowBox[{"j", ",", "n", ",", 
            RowBox[{"i", "+", "1"}], ",", 
            RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"id", "=", 
         RowBox[{"IdentityMatrix", "[", "dd", "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"dL", "=", 
         RowBox[{"Length", "[", "L", "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"dR", "=", 
         RowBox[{"Length", "[", "R", "]"}]}], ";", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", 
        RowBox[{"op", "=", 
         RowBox[{"TensorProduct", "[", 
          RowBox[{"L", ",", "id", ",", "R"}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"op", "=", 
         RowBox[{"Transpose", "[", 
          RowBox[{"op", ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "4", ",", "2", ",", "5", ",", "3", ",", "6"}], 
            "}"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
        RowBox[{"op", "=", 
         RowBox[{"Partition", "[", 
          RowBox[{
           RowBox[{"Flatten", "[", "op", "]"}], ",", 
           RowBox[{"dL", "*", "dR", "*", "dd"}]}], "]"}]}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"Return", "[", "op", "]"}], ";"}]}], "\[IndentingNewLine]", 
      "]"}]}], ";"}]}]}]], "Input",
 CellChangeTimes->{{3.731738123865749*^9, 3.731738135686507*^9}, {
   3.7317381778178263`*^9, 3.7317382286790667`*^9}, {3.731738370103701*^9, 
   3.731738423742928*^9}, {3.7317384677991533`*^9, 3.73173848827286*^9}, 
   3.731738548932756*^9, {3.7317386663160887`*^9, 3.731738726165338*^9}, {
   3.731738783338162*^9, 3.731738987694356*^9}, 3.7317401514055147`*^9, {
   3.7317408439324512`*^9, 
   3.731740870604911*^9}},ExpressionUUID->"98ef2411-2d8d-4a15-93c4-\
429049819256"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", " ", 
   RowBox[{
    RowBox[{"given", " ", "an", " ", "MPS"}], ",", " ", 
    RowBox[{"an", " ", "MPO"}], ",", " ", 
    RowBox[{
    "and", " ", "a", " ", "site", " ", "computes", " ", "the", " ", 
     "effective", " ", "Hamiltonian", " ", "matrix", " ", "that", " ", "goes",
      " ", "into", " ", "the", " ", "generalized", " ", "eigenvalue", " ", 
     "problem"}]}], " ", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"computeHeff", "[", 
     RowBox[{"MPS_", ",", "MPO_", ",", "i_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ","}], "\[IndentingNewLine]", 
     RowBox[{"(*", " ", 
      RowBox[{"igure", " ", "out", " ", "what", " ", "goes", " ", "here"}], 
      " ", "*)"}], "\[IndentingNewLine]", "]"}]}], ";"}]}]], "Input",
 CellChangeTimes->{{3.7317408805728197`*^9, 
  3.731740948735651*^9}},ExpressionUUID->"a71d57cc-ef56-4773-b263-\
ffb10e19f056"]
}, Open  ]]
},
WindowSize->{808, 911},
WindowMargins->{{4, Automatic}, {Automatic, 4}},
FrontEndVersion->"11.1 for Mac OS X x86 (32-bit, 64-bit Kernel) (April 27, \
2017)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[422, 15, 166, 3, 92, "Title", "ExpressionUUID" -> \
"da09aa66-471d-4279-88bf-6dec1671e47e"],
Cell[591, 20, 302, 7, 49, "Text", "ExpressionUUID" -> \
"e72bb2a1-d4c1-41a7-b7ab-5b1e8beea442"],
Cell[896, 29, 663, 13, 182, "Text", "ExpressionUUID" -> \
"7c41a873-fd8d-497e-a151-218992cb56e5"],
Cell[CellGroupData[{
Cell[1584, 46, 3756, 94, 535, "Input", "ExpressionUUID" -> \
"17821929-b98a-40c0-a22d-707fc8d5bc46"],
Cell[5343, 142, 571, 16, 32, "Output", "ExpressionUUID" -> \
"769dd58c-ddb5-4f34-99a4-a32be6fde816"]
}, Open  ]],
Cell[5929, 161, 592, 11, 68, "Text", "ExpressionUUID" -> \
"50a2c2be-9e63-44e3-a0e1-86c2c5a328b7"],
Cell[6524, 174, 761, 19, 96, "Input", "ExpressionUUID" -> \
"013792d5-11c6-45bc-be8b-469eeecf0630"],
Cell[CellGroupData[{
Cell[7310, 197, 202, 5, 32, "Input", "ExpressionUUID" -> \
"c911218f-76de-405f-8a08-05c35121d25f"],
Cell[7515, 204, 3003, 69, 159, "Output", "ExpressionUUID" -> \
"8f8be912-151e-42b1-b5f9-1c83f64393ca"]
}, Open  ]],
Cell[10533, 276, 635, 12, 106, "Text", "ExpressionUUID" -> \
"0c893a67-4942-4379-bb26-f747ed015f75"],
Cell[11171, 290, 1794, 44, 201, "Input", "ExpressionUUID" -> \
"a42616c0-05b4-49e6-957a-648c4ae2f0cf"],
Cell[12968, 336, 358, 10, 43, "Input", "ExpressionUUID" -> \
"463112a0-ce11-4c68-af60-9ffea4a520b7"],
Cell[13329, 348, 2638, 72, 193, "Text", "ExpressionUUID" -> \
"3a9b66ef-04f9-4a2e-ad16-0aea4a45f0b1"],
Cell[15970, 422, 1348, 32, 180, "Input", "ExpressionUUID" -> \
"02680977-89b0-47dd-8f32-8fcc9f17381e"],
Cell[17321, 456, 1821, 27, 505, "Text", "ExpressionUUID" -> \
"54607de3-0f12-421f-9552-2e95e42f3bee"],
Cell[19145, 485, 7146, 177, 852, "Input", "ExpressionUUID" -> \
"98ef2411-2d8d-4a15-93c4-429049819256"],
Cell[26294, 664, 967, 23, 138, "Input", "ExpressionUUID" -> \
"a71d57cc-ef56-4773-b263-ffb10e19f056"]
}, Open  ]]
}
]
*)

